program UniString;


uses vcl;

//$VCLDESIGN+
var
  Form1: Form;
  pan_main: Panel;
  relative: CheckBox;
  analyse: Button;
  auto: CheckBox;
  load1: Button;
  load2: Button;
  pan_text: Panel;
  but_ok: Button;
  file_load: Button;
  file_save: Button;
  textus1: TextBox;
  mypanel: Panel;
  num1_mask: Edit;
  str1_mask: Edit;
  str2_mask: Edit;
  num2_mask: Edit;
  str3_mask: Edit;
  open_file: OpenDialog;
  save_file: SaveDialog;
//$VCLDESIGN-



var i,n,m,k,l,z,strnum,loadto:integer;
str,st1:string;
box:ScrollBox;
tbnum1,tbnum2,tbstr1,tbstr2: array [1..1000] of edit;
  textus2: TextBox;
boo:boolean;

const
paddding=24;


procedure make_number_abs(i:integer);
begin
tbnum1[i].text:='0';
tbnum2[i].text:='0';
tbnum1[i].text:=inttostr(Length(tbstr1[i].text));
tbnum2[i].text:=inttostr(Length(tbstr2[i].text));
end;


procedure make_number_rel(i:integer);
begin
k:=Length(tbstr1[i].text)-Length(tbstr2[i].text);
if abs(k)<100 then begin
if k=0 then begin
tbnum1[i].text:='0';
tbnum2[i].text:='0';
end else begin
if k>0 then begin
tbnum1[i].text:='--';
tbnum2[i].text:='++';
if abs(k)<90 then begin
tbnum1[i].text:='-'+inttostr(k);
tbnum2[i].text:='+'+inttostr(k);
end;
end else begin
tbnum1[i].text:='++';
tbnum2[i].text:='--';
if abs(k)<90 then begin
tbnum1[i].text:='+'+inttostr(-k);
tbnum2[i].text:='-'+inttostr(-k);
end;
end;
end;
end;
end;


procedure tbstr2_OnChangeExt(Sender: Component);
begin
if not auto.Checked then exit;
for i:=1 to strnum do begin
if Sender=tbstr2[i] then begin
if not relative.Checked then
make_number_abs(i)
 else
make_number_rel(i)  ;
end;end;
end;


procedure tbstr1_OnChangeExt(Sender: Component);
begin
if not auto.Checked then exit;
for i:=1 to strnum do begin
if Sender=tbstr1[i] then begin
if not relative.Checked then
make_number_abs(i)
 else
make_number_rel(i)  ;
end;end;
end;

procedure create_tbstr1(i:integer);
begin
  tbstr1[i]:=Edit.Create(box,str1_mask.left,(i*paddding-(paddding div 2)),str1_mask.width,str1_mask.height);
  tbstr1[i].initcontrol(True,True,alNone,crDefault,clWindow,inttostr(i),'');
  tbstr1[i].Font.Name:= 'Courier New';
  tbstr1[i].Font.Size:= 14;
  tbstr1[i].Font.Style:= [fsbold];
  tbstr1[i].OnChangeExt:=tbstr1_OnChangeExt;
end;

procedure create_tbstr2(i:integer);
begin
  tbstr2[i]:=Edit.Create(box,str2_mask.left,(i*paddding-(paddding div 2)),str2_mask.width,str2_mask.height);
  tbstr2[i].initcontrol(True,True,alNone,crDefault,clWindow,inttostr(i),'');
  tbstr2[i].Font.Name:= 'Courier New';
  tbstr2[i].Font.Size:= 14;
  tbstr2[i].Font.Style:= [fsbold];
  tbstr2[i].OnChangeExt:=tbstr2_OnChangeExt;
end;

procedure create_tbnum1(i:integer);
begin
  tbnum1[i]:=Edit.Create(box,num1_mask.left,(i*paddding-(paddding div 2)),num1_mask.width,num1_mask.height);
  tbnum1[i].initcontrol(True,True,alNone,crDefault,clWindow,inttostr(i),'');
  tbnum1[i].Font.Name:= 'Courier New';
  tbnum1[i].Font.Size:= 14;
  tbnum1[i].Font.Style:= [fsbold];
  tbnum1[i].tabstop:=false;
end;

procedure create_tbnum2(i:integer);
begin
  tbnum2[i]:=Edit.Create(box,num2_mask.left,(i*paddding-(paddding div 2)),num2_mask.width,num2_mask.height);
  tbnum2[i].initcontrol(True,True,alNone,crDefault,clWindow,inttostr(i),'');
  tbnum2[i].Font.Name:= 'Courier New';
  tbnum2[i].Font.Size:= 14;
  tbnum2[i].Font.Style:= [fsbold];
  tbnum2[i].tabstop:=false;
end;




procedure show_textus;
begin
pan_main.visible:=false;
pan_text.visible:=true;
textus1.visible:=false;
mypanel.visible:=false;
textus2.visible:=false;

if loadto=1 then textus1.visible:=true else textus2.visible:=true;

textus1.lines.clear;
textus2.lines.clear;
for i:=1 to strnum do begin
textus1.lines.add(tbstr1[i].text);
textus2.lines.add(tbstr2[i].text);
tbstr1[i].destroy;
tbnum1[i].destroy;
tbstr2[i].destroy;
tbnum2[i].destroy;
end;

end;

procedure hide_textus;
begin
pan_main.visible:=true;
pan_text.visible:=false;
textus1.visible:=false;
textus2.visible:=false;
mypanel.visible:=true;
boo:=auto.Checked;
auto.Checked:=false;
strnum:=textus1.lines.count;
if strnum<textus2.lines.Size then strnum:=textus2.lines.count;

textus1.lines.Resize(strnum);
textus2.lines.Resize(strnum);

for i:=strnum downto 1 do begin
if (textus1.lines.Get(i)<>'')or(textus2.lines.Get(i)<>'')
then begin strnum:=i;break;end;
if i=1 then strnum:=1;
end;

textus1.lines.Resize(strnum);
textus2.lines.Resize(strnum);

for i:=1 to strnum do begin
  create_tbnum1(i);
  create_tbnum2(i);
  create_tbstr1(i);
  create_tbstr2(i);
tbstr1[i].text:=textus1.lines.get(i);
tbstr2[i].text:=textus2.lines.get(i);
end;


auto.Checked:=boo;
end;






procedure Form1OnCreate;
begin
  //!!!!!!!!!!!!!!!1
auto.Checked:= true;
relative.Checked:= false;
pan_text.visible:=false;

  textus2:= TextBox.Create(Form1,8,80,833,529);
  textus2.initcontrol(True,True,alNone,crDefault,clWindow,'','');
  textus2.ScrollBars:= ssBoth;

  box:=ScrollBox.Create(mypanel,0,0,mypanel.width,mypanel.height);
  box.initcontrol(True,True,alNone,crDefault,clBtnFace,'','');
  pan_main.BevelInner:= bvNone;
  pan_main.BevelOuter:= bvNone;
  pan_text.BevelInner:= bvNone;
  pan_text.BevelOuter:= bvNone;

  textus1.Font.Name:= 'Courier New';
  textus1.Font.Size:= 14;
  textus1.Font.Style:= [fsbold];

  textus2.Font.Name:= 'Courier New';
  textus2.Font.Size:= 14;
  textus2.Font.Style:= [fsbold];

  textus1.visible:=false;
  textus2.visible:=false;


strnum:=10;

for i:=1 to strnum do begin

  create_tbnum1(i);
  create_tbnum2(i);
  create_tbstr1(i);
  create_tbstr2(i);

end;

end;

procedure analyseOnClick;
begin

if not relative.Checked then begin
   for i:=1 to strnum do begin
make_number_abs(i)
   end;
  end else begin
   for i:=1 to strnum do begin
make_number_rel(i)
   end;
  end;
end;

procedure str1_maskOnChangeExt(Sender: Component);
begin
//
end;

procedure relativeOnClick;
begin
  analyseOnClick();
end;

procedure load1OnClick;
begin
loadto:=1;
show_textus();
end;

procedure load2OnClick;
begin
loadto:=2;
show_textus();
end;

procedure but_okOnClick;
begin
hide_textus();
end;

procedure file_loadOnClick;
begin
  open_file.title:='';
if open_file.execute then begin

if loadto=1 then
textus1.lines.LoadFromFile(open_file.filename)
else
textus2.lines.LoadFromFile(open_file.filename)

end;
end;

procedure file_saveOnClick;
begin
begin
  save_file.title:='';
if save_file.execute then begin

if loadto=1 then
textus1.lines.SaveToFile(save_file.filename)
else
textus2.lines.SaveToFile(save_file.filename)

end;
end;
end;

procedure InitControl;
begin
  Form1:= Form.Create(0,0,855,640);
  Form1.InitControl(True,False,alNone,crDefault,clBtnFace,'1','');
  pan_main:= Panel.Create(Form1,8,0,529,73);
  pan_main.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  relative:= CheckBox.Create(pan_main,168,16,153,17);
  relative.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  analyse:= Button.Create(pan_main,24,16,121,41);
  analyse.InitControl(True,True,alNone,crDefault,0,'!','');
  auto:= CheckBox.Create(pan_main,168,40,153,17);
  auto.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  load1:= Button.Create(pan_main,336,0,145,33);
  load1.InitControl(True,True,alNone,crDefault,0,' 1','');
  load2:= Button.Create(pan_main,336,40,145,33);
  load2.InitControl(True,True,alNone,crDefault,0,' 2','');
  pan_text:= Panel.Create(Form1,552,0,289,73);
  pan_text.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  but_ok:= Button.Create(pan_text,176,8,97,57);
  but_ok.InitControl(True,True,alNone,crDefault,0,'OK !','');
  file_load:= Button.Create(pan_text,8,0,137,33);
  file_load.InitControl(True,True,alNone,crDefault,0,'','');
  file_save:= Button.Create(pan_text,8,40,137,33);
  file_save.InitControl(True,True,alNone,crDefault,0,'','');
  textus1:= TextBox.Create(Form1,8,80,833,529);
  textus1.InitControl(True,True,alNone,crDefault,clWindow,'','');
  textus1.ScrollBars:= ssBoth;
  mypanel:= Panel.Create(Form1,8,80,833,521);
  mypanel.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  num1_mask:= Edit.Create(mypanel,8,8,41,29);
  num1_mask.InitControl(True,True,alNone,crDefault,clWindow,'1234','');
  str1_mask:= Edit.Create(mypanel,56,8,345,29);
  str1_mask.InitControl(True,True,alNone,crDefault,clWindow,'String','');
  str2_mask:= Edit.Create(mypanel,408,8,345,21);
  str2_mask.InitControl(True,True,alNone,crDefault,clWindow,'','');
  num2_mask:= Edit.Create(mypanel,760,8,41,21);
  num2_mask.InitControl(True,True,alNone,crDefault,clWindow,'','');
  str3_mask:= Edit.Create(mypanel,56,48,697,21);
  str3_mask.InitControl(True,True,alNone,crDefault,clWindow,'','');
  open_file:= OpenDialog.Create;
  save_file:= SaveDialog.Create;
  relative.Checked:= True;
  relative.Font.Name:= 'Arial';
  relative.Font.Size:= 12;
  analyse.Font.Name:= 'Arial';
  analyse.Font.Size:= 14;
  auto.Checked:= True;
  auto.Font.Name:= 'Arial';
  auto.Font.Size:= 12;
  load1.Font.Name:= 'Arial';
  load1.Font.Size:= 14;
  load2.Font.Name:= 'Arial';
  load2.Font.Size:= 14;
  but_ok.Font.Name:= 'Arial';
  but_ok.Font.Size:= 26;
  file_load.Font.Name:= 'Arial';
  file_load.Font.Size:= 14;
  file_save.Font.Name:= 'Arial';
  file_save.Font.Size:= 14;
  num1_mask.Font.Name:= 'Courier New';
  num1_mask.Font.Size:= 14;
  str1_mask.Font.Name:= 'Courier New';
  str1_mask.Font.Size:= 14;
  Form1.OnCreate:=Form1OnCreate;
  relative.OnClick:=relativeOnClick;
  analyse.OnClick:=analyseOnClick;
  load1.OnClick:=load1OnClick;
  load2.OnClick:=load2OnClick;
  but_ok.OnClick:=but_okOnClick;
  file_load.OnClick:=file_loadOnClick;
  file_save.OnClick:=file_saveOnClick;
  str1_mask.OnChangeExt:=str1_maskOnChangeExt;
  Form1.Position:= poScreenCenter;
  Form1.OnCreate;
  Form1.Show;
end;

begin
  InitControl;

end.

