program EightBitMaster;


//                    8 Bit Master v1.1 !
//          -  .
//              
//               8-  256 .
//               ,
//              256- ,
//             
//               
//             ,
//              ,
//               
//               
//           .
//           - 
//             256-
//             ( )
//             256-  
//            .
//            
//           
//            8-  
//               
//            .
//
//     - .
//
//       - , 
//         ,
//       ,     ,
//        ! !


uses vcl,pointrect;

//$VCLDESIGN+
var
  Form1: Form;
  txt1: TextLabel;
  txt2: TextLabel;
  but_get: Button;
  Panel1: Panel;
  table: PaintBox;
  but_enter: Button;
  Panel2: Panel;
  display: PaintBox;
  wd_tr: TrackBar;
  wd_ch: CheckBox;
  GroupBox1: GroupBox;
  lb_xx: TextLabel;
  lb_yy: TextLabel;
  lb_zz: TextLabel;
  TextLabel1: TextLabel;
  TextLabel2: TextLabel;
  but_load: Button;
  but_save: Button;
  but_showcolor: Button;
  but_clear: Button;
  Panel3: Panel;
  preview: PaintBox;
  but_load_pic: Button;
  but_save_code: Button;
  but_path: Button;
  path_red: RadioButton;
  path_green: RadioButton;
  path_blue: RadioButton;
  but_mid: Button;
  but_totab: Button;
  but_sv: Button;
  ch_rew: CheckBox;
  save_file: SaveDialog;
  open_file: OpenDialog;
//$VCLDESIGN-

var
tb:array[0..255] of byte;
col8: array [0..255,1..3] of byte  ;
col32: array[0..255] of integer    ;
col: array[1..3] of byte;
i,n,m,z,cl,k :integer;
f: file of byte;
b:byte;
bitmapo, bitmapp:bitmap;
const
capt='8-Bit-Master';


 procedure SetDisplay;
 begin
 if wd_ch.checked=true then begin
  display.width:=wd_tr.position;
 display.height:=(255+wd_tr.position) div wd_tr.position;
 lb_xx.caption:=inttostr(display.width);
 lb_yy.caption:=inttostr(display.height);
 lb_zz.caption:=inttostr(display.width*display.height);

 end else begin
   display.height:=wd_tr.position;
 display.width:=(255+wd_tr.position) div wd_tr.position;
 lb_xx.caption:=inttostr(display.width);
 lb_yy.caption:=inttostr(display.height);
 lb_zz.caption:=inttostr(display.height*display.width);

 end;
  i:=0; z:=0;
 for m:=0 to display.height-1 do begin
 for n:=0 to display.width-1 do begin
 display.setpixel(n,m,col32[z]);
 i:=i+1;if i<256 then z:=i else z:=0;
end;end;

 end;

procedure TableClear;
begin

 for i:=0 to 255 do begin
 tb[i]:=0;
 col8[i,1]:=0;
 col8[i,2]:=0;
 col8[i,3]:=0;
 col32[i]:=0;
 end;
 table.brush.style:=bsSolid;
 table.brush.color:=clblack;
 table.pen.color:=clblack;
 table.pen.style:=psSolid;
 table.pen.width:=1;
 table.FillRect(0,0,511,63);

    SetDisplay();

end;

  procedure TablePaint;
begin
    i:=0;
    for n:=0 to 255 do begin
    cl:=rgb(col8[n,1],col8[n,2],col8[n,3]);
    table.pen.color:=cl;
    table.Line(i,0,i,32);
    i:=i+1;
    table.Line(i,0,i,32);
    i:=i+1;
    end;

    i:=0;
    for n:=0 to 255 do begin
    cl:=col32[n];
    table.pen.color:=cl;
    table.Line(i,32,i,63);
    i:=i+1;
    table.Line(i,32,i,63);
    i:=i+1;
    end;

end;


procedure Form1OnCreate;
begin
bitmapo:=bitmap.create;
bitmapp:=bitmap.create;
  form1.Caption:=capt;
  wd_tr.position:=16;
  wd_ch.checked:=false;
  ch_rew.checked:=true;
   TableClear();

  txt1.caption:='8-Bit-Master v1.1!  -  .';
  txt2.caption:=' -       !';

end;

procedure but_getOnClick;
begin
open_file.Filter:='*|*.bmp';
open_file.title:='     256 ';
if (open_file.execute)and(fileexists(open_file.filename)) then begin
    TableClear();
    assign(f,open_file.filename);
    Reset(f);
    seek(f,28);
    read(f,b);
    if b<>8 then begin  close(f);exit end;

    Seek(f,54);
    for i:=0 to 255 do begin
    read(f,b);
    col8[i,3]:=b;
    read(f,b);
    col8[i,2]:=b;
    read(f,b);
    col8[i,1]:=b;
    col32[i]:=rgb(col8[i,1],col8[i,2],col8[i,3]);
        read(f,b);

    end;
 close(f);
 TablePaint()  ;
 SetDisplay()  ;

end;
end;


procedure but_enterOnClick;
begin
     open_file.Filter:='*|*.bmp';
open_file.title:=' ,      ';

if (open_file.execute)and(fileexists(open_file.filename)) then begin
    assign(f,open_file.filename)  ;
    Reset(f);

    seek(f,28);
    read(f,b);
    if b<>8 then begin  close(f);exit end;

    Seek(f,54);
    for i:=0 to 255 do begin
    b:=col8[i,3];
    write(f,b);
    b:=col8[i,2];
    write(f,b);
    b:=col8[i,1];
    write(f,b);
    write(f,0);
end;
 close(f);
end;
end;

procedure wd_trOnChange;
begin
SetDisplay  ()  ;
end;

procedure wd_chOnClick;
begin
   SetDisplay  () ;
end;

procedure but_loadOnClick;
begin
   SetDisplay  () ;
     open_file.Filter:='*|*.bmp';
open_file.title:='        ';
if (open_file.execute)and(fileexists(open_file.filename)) then begin

    assign(f,open_file.filename)  ;
    Reset(f);

    seek(f,28);
    read(f,b);
    if b=8 then begin  close(f);exit end;
   close(f);

 bitmapo.LoadFromFile(open_file.filename);
 display.canvas.CopyRect(rectf(0,0,bitmapo.width,bitmapo.height),bitmapo.canvas,rectf(0,0,bitmapo.width,bitmapo.height));

  i:=0; z:=0;
 for m:=0 to display.height-1 do begin
 for n:=0 to display.width-1 do begin
 cl:=display.getpixel(n,m);
    col8[z,1]:=getred(cl);
    col8[z,2]:=getgreen(cl);
    col8[z,3]:=getblue(cl);
    col32[z]:=rgb(col8[z,1],col8[z,2],col8[z,3]);
 i:=i+1;if i<256 then z:=i else z:=0;
end;end;
  TablePaint();
end;
end;

procedure but_saveOnClick;
begin
     save_file.Filter:='*|*.bmp';
save_file.title:='       ';
if save_file.execute then begin
  bitmapo.width:=display.width;
  bitmapo.height:=display.height;
 bitmapo.canvas.CopyRect(rectf(0,0,display.width,display.height),display.canvas,rectf(0,0,display.width,display.height));
   bitmapo.savetoFile(save_file.filename);

end;
end;

procedure but_clearOnClick;
begin
     TableClear();
     SetDisplay();
 preview.brush.style:=bsSolid;
 preview.brush.color:=clwhite;
 preview.pen.color:=clwhite;
 preview.pen.style:=psSolid;
 preview.pen.width:=1;
 preview.FillRect(0,0,preview.width-1,preview.height-1);
end;

procedure but_load_picOnClick;
begin
         open_file.Filter:='*|*.bmp';
open_file.title:='  ';
if (open_file.execute)and(fileexists(open_file.filename)) then begin

   if true then begin
   assign(f,open_file.filename);
    Reset(f);
    seek(f,28);
    read(f,b);
    if b=8 then begin  close(f);exit end;
    close(f);
  end;
 bitmapp.LoadFromFile(open_file.filename);
 preview.canvas.CopyRect(rectf(0,0,preview.width,preview.height),bitmapp.canvas,rectf(0,0,preview.width,preview.height));

end;
end;

procedure but_save_codeOnClick;
begin
       save_file.Filter:='*|*.bmp';
save_file.title:='  ,       ';
if save_file.execute then begin
  assign(f,save_file.filename);
  rewrite(f);
 z:=0;
 if path_red.checked=true then z:=1;
  if path_green.checked=true then z:=2;
   if path_blue.checked=true then z:=3;

if ch_rew.checked=true then begin
 for m:=bitmapp.height-1 downto 0 do begin
 for n:=0 to bitmapp.width-1 do begin
 cl:=bitmapp.canvas.getpixel(n,m);
 col[1]:=getred(cl);
 col[2]:=getgreen(cl);
 col[3]:=getblue(cl);
 write(f,col[z]);
 end;end;

 end else begin

 for m:=0 downto bitmapp.height-1 do begin
 for n:=0 to bitmapp.width-1 do begin
 cl:=bitmapp.canvas.getpixel(n,m);
 col[1]:=getred(cl);
 col[2]:=getgreen(cl);
 col[3]:=getblue(cl);
 write(f,col[z]);
 end;end;
 end;
close(f);
end;
end;

procedure but_pathOnClick;
begin

open_file.Filter:='*|*.bmp';
open_file.title:=' 256-   ,      ';

if (open_file.execute)and(fileexists(open_file.filename)) then begin

 z:=0;
 if path_red.checked=true then z:=1;
  if path_green.checked=true then z:=2;
   if path_blue.checked=true then z:=3;

    assign(f,open_file.filename)  ;
    Reset(f);
      seek(f,28);
      read(f,b);
       if b<>8 then begin  close(f);exit end;
    Seek(f,1079);
    if ch_rew.checked=true then begin
             for m:=bitmapp.height-1 downto 0 do begin
             for n:=0 to bitmapp.width-1 do begin
             cl:=bitmapp.canvas.getpixel(n,m);
             col[1]:=getred(cl);
             col[2]:=getgreen(cl);
             col[3]:=getblue(cl);
              write(f,col[z]);
              end;
              write(f,0,0);end;
      end else begin
             for m:=0 to bitmapp.height-1 do begin
             for n:=0 to bitmapp.width-1 do begin
             cl:=bitmapp.canvas.getpixel(n,m);
             col[1]:=getred(cl);
             col[2]:=getgreen(cl);
             col[3]:=getblue(cl);
              write(f,col[z]);
              end;
              write(f,0,0);end;
      end;
 close(f);
end;
end;

procedure but_svOnClick;
begin
 save_file.Filter:='*|*.bmp';
save_file.title:='    ';
if save_file.execute then begin
 bitmapp.savetoFile(save_file.filename);
 end;
end;



procedure but_midOnClick;
var
mar: array [0..640, 0..480 , 0..7] of integer;
can: array [1..3] of integer;
label new,ext;
begin  z:=0;

new:

 for m:=0 to bitmapp.height-1 do begin
 for n:=0 to bitmapp.width-1 do begin
 mar[n,m,z]:=bitmapp.canvas.getpixel(n,m);
 end;end;
 z:=z+1 ;
 if z=8 then goto ext;
 open_file.Filter:='*|*.bmp';
 open_file.title:='   , : '+inttostr(z)+ '.  -  ';

if (open_file.execute)and(fileexists(open_file.filename)) then begin
    bitmapp.loadfromFile(open_file.filename);
   goto new; end;

ext:

 for m:=0 to bitmapp.height-1 do begin
 for n:=0 to bitmapp.width-1 do begin
  can[1]:=0;can[2]:=0;can[3]:=0;
    for i:=0 to z-1 do begin
    cl:=mar[n,m,i];
    can[1]:=can[1]+getred(cl);
    can[2]:=can[2]+getgreen(cl);
    can[3]:=can[3]+getblue(cl);
    end;
  can[1]:=trunc(Round(can[1]/z));
  can[2]:=trunc(Round(can[2]/z));
  can[3]:=trunc(Round(can[3]/z));
  bitmapp.canvas.setpixel(n,m,rgb(can[1],can[2],can[3]));
 end;end;
 preview.canvas.CopyRect(rectf(0,0,preview.width,preview.height),bitmapp.canvas,rectf(0,0,preview.width,preview.height));

end;

procedure but_totabOnClick;
const
source1='SourceRed.tmp';
source2='SourceGreen.tmp';
source3='SourceBlue.tmp';
palette1='PaletteRed.tmp';
palette2='PaletteGreen.tmp';
palette3='PaletteBlue.tmp';
dest='Destination.tmp';
mask='Mask.tmp';
outmask='Mask As Bitmap.bmp';
outdest='Destination In Gray.bmp';
var
f1,f2,f3, f4,f5,f6, f7,f8:file of byte;
c1,c2,c3,i1,i2,i3:byte;
st,temp:string;
label
ok;
begin

 save_file.Filter:='*|*';
save_file.title:='   .    !';
if not (save_file.execute) then exit;
temp:=save_file.filename;


form1.enabled:=false;
form1.Caption:='';

assign(f1,temp+source1);
assign(f2,temp+source2);
assign(f3,temp+source3);
rewrite(f1);rewrite(f2);rewrite(f3);
k:=-1;
 for m:=0 to bitmapp.height-1 do begin
 for n:=0 to bitmapp.width-1 do begin
 cl:=bitmapp.canvas.getpixel(n,m);
 k:=k+1;
  write(f1,getred(cl));
  write(f2,getgreen(cl));
  write(f3,getblue(cl));
 end;end;

seek(f1,0);seek(f2,0);seek(f3,0);

assign(f4,temp+palette1);
assign(f5,temp+palette2);
assign(f6,temp+palette3);
rewrite(f4);rewrite(f5);rewrite(f6);

 for n:=0 to 255 do begin
  write(f4,col8[n,1]);
  write(f5,col8[n,2]);
  write(f6,col8[n,3]);
 end;

seek(f4,0);seek(f5,0);seek(f6,0);

for i:=0 to 255 do begin
assign(f,temp+inttostr(i)+'.tmp');
rewrite(f);
read(f4,c1);read(f5,c2);read(f6,c3);
seek(f1,0);seek(f2,0);seek(f3,0);
for n:=0 to k do begin
m:=0;
read(f1,i1);read(f2,i2);read(f3,i3);
m:=m+abs(i1-c1)+abs(i2-c2)+abs(i3-c3);
if m>255 then m:=255;
write(f,m);
end;close(f);end;

assign(f7,temp+mask);
assign(f8,temp+dest);
rewrite(f7);rewrite(f8);
for z:=0 to k do begin
write(f7,255);write(f8,0);
end;

  m:=0;
 seek(f1,0);seek(f2,0);seek(f3,0);seek(f4,0);seek(f5,0);seek(f6,0);seek(f7,0);seek(f8,0);
 st:='/'+inttostr(k);
 for z:=0 to 254 do begin //
  for i:=0 to 255 do begin //
  assign(f,temp+inttostr(i)+'.tmp');
  reset(f);seek(f7,0);
   for n:=0 to k do begin //
   read(f,c1);read(f7,c2);
   if (c2=255) and (c1=z) then begin
      seek(f7,n); write(f7,z);
      seek(f8,n); write(f8,i);
       m:=m+1;
        form1.caption:=inttostr(m)+st;
        Application.ProcessMessages;
       if m=k then begin  close(f); goto ok; end;
      end;
   end;
  close(f);
  end;
 end;

ok:
seek(f1,0);seek(f2,0);seek(f3,0);seek(f4,0);seek(f5,0);seek(f6,0);seek(f7,0);seek(f8,0);

 for m:=0 to bitmapp.height-1 do begin
 for n:=0 to bitmapp.width-1 do begin
  read(f7,b); b:=255-b;
 bitmapp.canvas.setpixel(n,m,rgb(b,b,b));
 end;end;

 bitmapp.savetofile(temp+outmask);

 for m:=0 to bitmapp.height-1 do begin
 for n:=0 to bitmapp.width-1 do begin
  read(f8,b);
 bitmapp.canvas.setpixel(n,m,rgb(b,b,b));
 end;end;

 bitmapp.savetofile(temp+outdest);
  preview.canvas.CopyRect(rectf(0,0,preview.width,preview.height),bitmapp.canvas,rectf(0,0,preview.width,preview.height));

 close(f1);close(f2);close(f3);close(f4);close(f5);close(f6);close(f7);close(f8);
 form1.enabled:=true;
 form1.Caption:=capt;



end;




procedure but_showcolorOnClick;
var xx,yy:integer;
begin

    display.width:=103;
   display.height:=103;
 display.brush.style:=bsSolid;
 display.brush.color:=clwhite;
 display.pen.color:=clwhite;
 display.pen.style:=psSolid;
 display.pen.width:=1;
 display.FillRect(0,0,display.width-1,display.height-1);
   xx:=0;yy:=0;
 i:=0;z:=-1;n:=0;m:=-3;
  for k:=0 to 15 do begin
   m:=m+3;
  for n:=0 to 47 do begin
  z:=z+1;
  if z=3 then begin z:=0; i:=i+1; end;
     display.setpixel(n+xx,yy+m+0,rgb(col8[i,1],0,0));
    display.setpixel(n+xx,yy+m+1,rgb(col8[i,1],0,0));
    display.setpixel(n+xx,yy+m+2,rgb(col8[i,1],0,0));
  end;end;


  xx:=55;yy:=0;
 i:=0;z:=-1;n:=0;m:=-3;
  for k:=0 to 15 do begin
   m:=m+3;
  for n:=0 to 47 do begin
  z:=z+1;
  if z=3 then begin z:=0; i:=i+1; end;
    display.setpixel(n+xx,yy+m+0,rgb(0,col8[i,2],0));
    display.setpixel(n+xx,yy+m+1,rgb(0,col8[i,2],0));
    display.setpixel(n+xx,yy+m+2,rgb(0,col8[i,2],0));

  end;end;


  xx:=0;yy:=55;
 i:=0;z:=-1;n:=0;m:=-3;
  for k:=0 to 15 do begin
   m:=m+3;
  for n:=0 to 47 do begin
  z:=z+1;
  if z=3 then begin z:=0; i:=i+1; end;
    display.setpixel(n+xx,yy+m+0,rgb(0,0,col8[i,3]));
    display.setpixel(n+xx,yy+m+1,rgb(0,0,col8[i,3]));
    display.setpixel(n+xx,yy+m+2,rgb(0,0,col8[i,3]));
  end;end;

   xx:=55;yy:=55;
 i:=0;z:=-1;n:=0;m:=-3;
  for k:=0 to 15 do begin
   m:=m+3;
  for n:=0 to 47 do begin
  z:=z+1;
  if z=3 then begin z:=0; i:=i+1; end;
    display.setpixel(n+xx,yy+m+0,rgb(col8[i,1],col8[i,2],col8[i,3]));
    display.setpixel(n+xx,yy+m+1,rgb(col8[i,1],col8[i,2],col8[i,3]));
    display.setpixel(n+xx,yy+m+2,rgb(col8[i,1],col8[i,2],col8[i,3]));
  end;end;
end;

procedure tableOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    .';
  txt2.caption:='   ,   .';
end;

procedure Form1OnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='8-Bit-Master v1.1!  -  .';
  txt2.caption:=' -       !';
end;

procedure but_getOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    .';
  txt2.caption:='  256- BMP!';
end;

procedure but_enterOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='     .';
  txt2.caption:=',   256- BMP!';
end;

procedure but_clearOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   .';
  txt2.caption:='  .';
end;

procedure displayOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='      .';
  txt2.caption:='    .    .';
end;

procedure but_loadOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='      .';
  txt2.caption:='       .';
end;

procedure but_saveOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    .';
  txt2.caption:='   .';
end;

procedure but_showcolorOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   16*16   .';
  txt2.caption:=',  ,   .';
end;

procedure wd_chOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    .';
  txt2.caption:='      .';
end;

procedure GroupBox1OnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   .';
  txt2.caption:='   255.';
end;

procedure wd_trOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   ,  1  16.';
  txt2.caption:='  ,  .';
end;

procedure previewOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    .';
  txt2.caption:='      !';
end;

procedure but_pathOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    256- BMP.  ;';
  txt2.caption:='     !';
end;

procedure path_redOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   .';
  txt2.caption:='  "  "  " "';
end;

procedure path_greenOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='  ˨ .';
  txt2.caption:='  "  "  " "';
end;

procedure path_blueOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   .';
  txt2.caption:='  "  "  " "';
end;

procedure ch_rewOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='    .';
  txt2.caption:='   BMP.';
end;

procedure but_totabOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='   256   .';
  txt2.caption:='  .   !!!';
end;

procedure but_midOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='      . .';
  txt2.caption:=': 640*480,    .';
end;

procedure but_svOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='  .';
  txt2.caption:=' ,  .';
end;

procedure but_load_picOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='  BMP  .';
  txt2.caption:=' , 16  !';
end;

procedure but_save_codeOnMouseDown(x,y,button: integer);
begin
  if button<>2 then exit;
  txt1.caption:='      . ';
  txt2.caption:='   (  )';
end;

procedure InitControl;
begin
  Form1:= Form.Create(0,0,554,541);
  Form1.InitControl(True,False,alNone,crDefault,clBtnFace,'1','');
  txt1:= TextLabel.Create(Form1,8,448,11,22);
  txt1.InitControl(True,True,alNone,crDefault,clBtnFace,'0','');
  txt2:= TextLabel.Create(Form1,8,480,11,22);
  txt2.InitControl(True,True,alNone,crDefault,clBtnFace,'0','');
  but_get:= Button.Create(Form1,8,96,97,41);
  but_get.InitControl(True,True,alNone,crDefault,0,'','');
  Panel1:= Panel.Create(Form1,8,8,529,81);
  Panel1.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  table:= PaintBox.Create(Panel1,8,8,512,64);
  table.InitControl(True,True,alNone,crDefault,0,'0','');
  but_enter:= Button.Create(Form1,112,96,81,41);
  but_enter.InitControl(True,True,alNone,crDefault,0,'','');
  Panel2:= Panel.Create(Form1,8,144,273,289);
  Panel2.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  display:= PaintBox.Create(Panel2,8,8,137,113);
  display.InitControl(True,True,alNone,crDefault,0,'0','');
  wd_tr:= TrackBar.Create(Panel2,72,232,193,33);
  wd_tr.InitControl(True,True,alNone,crDefault,clBtnFace,'wd_tr','');
  wd_ch:= CheckBox.Create(Panel2,168,160,81,17);
  wd_ch.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  GroupBox1:= GroupBox.Create(Panel2,80,184,185,40);
  GroupBox1.InitControl(True,True,alNone,crDefault,clBtnFace,':','');
  lb_xx:= TextLabel.Create(GroupBox1,24,16,9,18);
  lb_xx.InitControl(True,True,alNone,crDefault,clBtnFace,'0','');
  lb_yy:= TextLabel.Create(GroupBox1,80,16,9,18);
  lb_yy.InitControl(True,True,alNone,crDefault,clBtnFace,'0','');
  lb_zz:= TextLabel.Create(GroupBox1,152,16,9,18);
  lb_zz.InitControl(True,True,alNone,crDefault,clBtnFace,'0','');
  TextLabel1:= TextLabel.Create(GroupBox1,54,14,13,22);
  TextLabel1.InitControl(True,True,alNone,crDefault,clBtnFace,'X','');
  TextLabel2:= TextLabel.Create(GroupBox1,120,14,11,18);
  TextLabel2.InitControl(True,True,alNone,crDefault,clBtnFace,'=','');
  but_load:= Button.Create(Panel2,168,40,97,33);
  but_load.InitControl(True,True,alNone,crDefault,0,'','');
  but_save:= Button.Create(Panel2,168,80,97,33);
  but_save.InitControl(True,True,alNone,crDefault,0,'','');
  but_showcolor:= Button.Create(Panel2,168,120,97,33);
  but_showcolor.InitControl(True,True,alNone,crDefault,0,'...','');
  but_clear:= Button.Create(Form1,200,96,81,41);
  but_clear.InitControl(True,True,alNone,crDefault,0,'','');
  Panel3:= Panel.Create(Form1,288,96,249,337);
  Panel3.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  preview:= PaintBox.Create(Panel3,8,168,233,161);
  preview.InitControl(True,True,alNone,crDefault,0,'0','');
  but_load_pic:= Button.Create(Panel3,16,8,145,25);
  but_load_pic.InitControl(True,True,alNone,crDefault,0,' ','');
  but_save_code:= Button.Create(Panel3,16,40,145,25);
  but_save_code.InitControl(True,True,alNone,crDefault,0,'  ','');
  but_path:= Button.Create(Panel3,16,72,145,25);
  but_path.InitControl(True,True,alNone,crDefault,0,' ','');
  path_red:= RadioButton.Create(Panel3,168,8,73,17);
  path_red.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  path_green:= RadioButton.Create(Panel3,168,32,73,17);
  path_green.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  path_blue:= RadioButton.Create(Panel3,168,56,57,17);
  path_blue.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  but_mid:= Button.Create(Panel3,16,136,113,25);
  but_mid.InitControl(True,True,alNone,crDefault,0,'...','');
  but_totab:= Button.Create(Panel3,16,104,225,25);
  but_totab.InitControl(True,True,alNone,crDefault,0,'  ','');
  but_sv:= Button.Create(Panel3,144,136,97,25);
  but_sv.InitControl(True,True,alNone,crDefault,0,'','');
  ch_rew:= CheckBox.Create(Panel3,168,80,73,17);
  ch_rew.InitControl(True,True,alNone,crDefault,clBtnFace,'','');
  save_file:= SaveDialog.Create;
  open_file:= OpenDialog.Create;
  txt1.Font.Name:= 'Arial';
  txt1.Font.Size:= 14;
  txt2.Font.Name:= 'Arial';
  txt2.Font.Size:= 14;
  but_get.Font.Name:= 'Arial';
  but_get.Font.Size:= 10;
  but_enter.Font.Name:= 'Arial';
  but_enter.Font.Size:= 10;
  wd_tr.Min:= 1;
  wd_tr.Max:= 16;
  wd_tr.Position:= 16;
  wd_tr.MarkerSize:= 20;
  wd_tr.TickMarks:= tmBoth;
  wd_ch.Checked:= True;
  wd_ch.Font.Name:= 'Arial';
  wd_ch.Font.Size:= 10;
  GroupBox1.Font.Name:= 'Arial';
  GroupBox1.Font.Size:= 9;
  lb_xx.Font.Name:= 'Arial';
  lb_xx.Font.Size:= 12;
  lb_yy.Font.Name:= 'Arial';
  lb_yy.Font.Size:= 12;
  lb_zz.Font.Name:= 'Arial';
  lb_zz.Font.Size:= 12;
  TextLabel1.Font.Name:= 'Arial';
  TextLabel1.Font.Size:= 14;
  TextLabel2.Font.Name:= 'Arial';
  TextLabel2.Font.Size:= 14;
  but_load.Font.Name:= 'Arial';
  but_load.Font.Size:= 10;
  but_save.Font.Name:= 'Arial';
  but_save.Font.Size:= 10;
  but_showcolor.Font.Name:= 'Arial';
  but_showcolor.Font.Size:= 10;
  but_clear.Font.Name:= 'Arial';
  but_clear.Font.Size:= 10;
  but_load_pic.Font.Name:= 'Arial';
  but_load_pic.Font.Size:= 10;
  but_save_code.Font.Name:= 'Arial';
  but_save_code.Font.Size:= 10;
  but_path.Font.Name:= 'Arial';
  but_path.Font.Size:= 10;
  path_red.Checked:= True;
  path_red.Font.Name:= 'Arial';
  path_red.Font.Size:= 10;
  path_green.Font.Name:= 'Arial';
  path_green.Font.Size:= 10;
  path_blue.Font.Name:= 'Arial';
  path_blue.Font.Size:= 10;
  but_mid.Font.Name:= 'Arial';
  but_mid.Font.Size:= 10;
  but_totab.Font.Name:= 'Arial';
  but_totab.Font.Size:= 10;
  but_sv.Font.Name:= 'Arial';
  but_sv.Font.Size:= 10;
  ch_rew.Checked:= True;
  ch_rew.Font.Name:= 'Arial';
  ch_rew.Font.Size:= 10;
  Form1.OnCreate:=Form1OnCreate;
  Form1.OnMouseDown:=Form1OnMouseDown;
  but_get.OnClick:=but_getOnClick;
  but_get.OnMouseDown:=but_getOnMouseDown;
  table.OnMouseDown:=tableOnMouseDown;
  but_enter.OnClick:=but_enterOnClick;
  but_enter.OnMouseDown:=but_enterOnMouseDown;
  display.OnMouseDown:=displayOnMouseDown;
  wd_tr.OnChange:=wd_trOnChange;
  wd_tr.OnMouseDown:=wd_trOnMouseDown;
  wd_ch.OnClick:=wd_chOnClick;
  wd_ch.OnMouseDown:=wd_chOnMouseDown;
  GroupBox1.OnMouseDown:=GroupBox1OnMouseDown;
  but_load.OnClick:=but_loadOnClick;
  but_load.OnMouseDown:=but_loadOnMouseDown;
  but_save.OnClick:=but_saveOnClick;
  but_save.OnMouseDown:=but_saveOnMouseDown;
  but_showcolor.OnClick:=but_showcolorOnClick;
  but_showcolor.OnMouseDown:=but_showcolorOnMouseDown;
  but_clear.OnClick:=but_clearOnClick;
  but_clear.OnMouseDown:=but_clearOnMouseDown;
  preview.OnMouseDown:=previewOnMouseDown;
  but_load_pic.OnClick:=but_load_picOnClick;
  but_load_pic.OnMouseDown:=but_load_picOnMouseDown;
  but_save_code.OnClick:=but_save_codeOnClick;
  but_save_code.OnMouseDown:=but_save_codeOnMouseDown;
  but_path.OnClick:=but_pathOnClick;
  but_path.OnMouseDown:=but_pathOnMouseDown;
  path_red.OnMouseDown:=path_redOnMouseDown;
  path_green.OnMouseDown:=path_greenOnMouseDown;
  path_blue.OnMouseDown:=path_blueOnMouseDown;
  but_mid.OnClick:=but_midOnClick;
  but_mid.OnMouseDown:=but_midOnMouseDown;
  but_totab.OnClick:=but_totabOnClick;
  but_totab.OnMouseDown:=but_totabOnMouseDown;
  but_sv.OnClick:=but_svOnClick;
  but_sv.OnMouseDown:=but_svOnMouseDown;
  ch_rew.OnMouseDown:=ch_rewOnMouseDown;
  Form1.Position:= poScreenCenter;
  Form1.OnCreate;
  Form1.Show;
end;

begin
  InitControl;

end.
